/var/lib/pcp/testsuite/964 is in pcp-testsuite 4.0.1-1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 | #!/bin/sh
# PCP QA Test No. 964
# Ensure pmlogger not (re)started via PMDA Install.
#
# We cannot use a PMDA that _might_ provide metrics that the primary
# pmlogger is logging ... when we Remove that PMDA, then pmlogger will
# at some point notice the metrics have gone away and exit ... leaving
# no pmlogger to be tested in this test case.
#
# So we use the test_perl PMDA.
#
# Copyright (c) 2015-2016 Red Hat.
#
seq=`basename $0`
echo "QA output created by $seq"
# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check
perl -e "use PCP::PMDA" >/dev/null 2>&1
[ $? -eq 0 ] || _notrun "perl PCP::PMDA module not installed"
status=1 # failure is the default!
_needclean=true
$sudo rm -rf $tmp $tmp.* $seq.full
_interrupt()
{
status=1
}
_cleanup()
{
cd $here
if $_needclean
then
if pmprobe -I pmcd.agent.status | grep '"test_perl"' >/dev/null
then
cd $here/pmdas/test_perl
$sudo ./Remove >>$here/$seq.full 2>&1
$sudo rm -f domain.h.perl
cd $here
fi
_needclean=false
fi
$sudo rm -f $tmp.*
exit $status
}
trap "_cleanup" 0
trap "_interrupt; _cleanup" 1 2 3 15
_stop_auto_restart pmcd
_find_primary_pmlogger()
{
if [ -d $PCP_TMP_DIR/pmlogger ]
then
cd $PCP_TMP_DIR/pmlogger
ls -l >>$here/$seq.full
if [ -L primary ]
then
echo "`ls -l primary | sed -e 's;.*/;;'`"
else
echo "No primary logger file?" >>$here/$seq.full
fi
fi
}
_filter_test_perl_install()
{
_filter_pmda_install \
| _filter_pcp_stop \
| tee -a $here/$seq.full \
| $PCP_AWK_PROG '
/Check test_perl metrics have appeared/ { if ($7 >= 0) $7 = "X"
if ($10 >= 0) $10 = "Y"
}
{ print }'
}
# real QA test starts here
pmcd_pid=`_get_pids_by_name pmcd`
if [ -n "$pmcd_pid" ]
then
echo "Found initial pmcd"
else
echo "Error: initial pmcd missing?"
exit
fi
pid=`_find_primary_pmlogger`
if [ -n "$pid" ]
then
echo "Found primary pmlogger"
else
echo "Error: primary pmlogger missing?"
fi
echo
cd pmdas/test_perl
# install a PMDA, which should NOT restart pmcd
$sudo ./Install </dev/null \
| _filter_test_perl_install
# verify pmcd not restarted
#
new_pmcd_pid=`_get_pids_by_name pmcd`
if [ -n "$new_pmcd_pid" ]
then
if [ "$pmcd_pid" = "$new_pmcd_pid" ]
then
echo "Found same pmcd"
else
echo "Error: pmcd restarted? PID changed from $pmcd_pid to $new_pmcd_pid"
pmcd_pid=$new_pmcd_pid
fi
else
echo "Error: pmcd missing?"
exit
fi
# verify primary pmlogger still running
#
echo "Expect same primary pmlogger to be running ..."
newpid=`_find_primary_pmlogger`
if [ -n "$newpid" ]
then
if [ "$pid" = "$newpid" ]
then
echo "Found same primary pmlogger"
else
echo "Found new primary pmlogger"
echo "Error: PID changed from $pid to $newpid"
pid=$newpid
fi
else
echo "Error: primary pmlogger missing?"
fi
echo
# install a PMDA, should restart pmcd ...
# historically this would have caused the primary pmlogger to
# be restarted, but these days pmlogger will reconnect to the new
# pmcd here ...
#
$sudo sh -c "PCPQA_RESTART_PMCD=true ./Install </dev/null" \
| _filter_test_perl_install
# verify pmcd restarted
#
new_pmcd_pid=`_get_pids_by_name pmcd`
if [ -n "$new_pmcd_pid" ]
then
if [ "$pmcd_pid" = "$new_pmcd_pid" ]
then
echo "Error: found the same pmcd"
else
echo "Found a new pmcd"
fi
else
echo "Error: new pmcd missing?"
exit
fi
# verify primary pmlogger still running
#
echo "Expect same primary pmlogger to be running ..."
newpid=`_find_primary_pmlogger`
if [ -n "$newpid" ]
then
if [ "$pid" = "$newpid" ]
then
echo "Found same primary pmlogger"
else
echo "Found new primary pmlogger"
echo "Error: PID changed from $pid to $newpid"
pid=$newpid
fi
else
echo "Error: primary pmlogger missing?"
fi
echo
# success, all done
status=0
exit
|